﻿#!/usr/bin/perl -w
use strict;
use warnings;

# perl SeqSlicer.pl seqFile.txt scaffold_66 10 20

my $seqFile    = "$ARGV[0]";
my $recNameKey = "$ARGV[1]";
my $start      = "$ARGV[2]";
my $end        = "$ARGV[3]";

open(INFILE,"$seqFile") or die "$!";
my @ins = <INFILE>;
close INFILE;

my ($ref_recs, $ref_names) = &fasHashReader(\@ins);
my @names = @$ref_names;
my %recs  = %$ref_recs;

$recNameKey = ">".$recNameKey;
my $recName = "";
#unless($recName = join('', grep(/$recNameKey/, @names))){
unless($recName = join('', grep($_ eq "$recNameKey", @names))){
  print "Cannot find $recNameKey.\n"; 
  exit;
}
#print "recName|$recName|\n";

my $seq = $recs{$recName};
my $len = $end - $start;
my $partSeq = substr($seq, $start-1, $len);
print "$partSeq\n";
print "\n";
my $partSeqRC = &revCom($partSeq);
print "$partSeqRC\n";



exit;


sub fasHashReader
{
  my $name = "";
  my $seq = "";
  my $flag = 0;
  my @nameArraySR = ( );
  my %fasHashSR = ( );

  my ($inFileContSR) = @_;

  foreach my $inFileLine (@$inFileContSR) {
    chomp($inFileLine);
    if($inFileLine =~ /^>/){  
      if($flag == 0){
        $name = $inFileLine;
        $flag = 1;  
      } else {
        $fasHashSR{$name} = $seq;  
        push(@nameArraySR,$name);
        $name = "$inFileLine";
        $seq = "";
      }
    } else {
      $seq .= $inFileLine; 
    }
  }
  $fasHashSR{$name} = $seq;
  push(@nameArraySR,$name);

  return (\%fasHashSR,\@nameArraySR);
}


sub revCom {
  my ($seqLine) = @_;
  my $revcomp = reverse($seqLine);
  $revcomp =~ tr/ATGCatgc
                /TACGtacg/;
  $revcomp =~ tr/atgc/ATGC/;
  return ($revcomp);
}
